-- http://www.alexvolok.com/2015/06/sql-2016-temporal-tables-introduction/#more-24

DROP DATABASE IF EXISTS SQL2016Demo;
GO

-- step 1: Create database, tables and seed dummy data
CREATE DATABASE SQL2016Demo
ON PRIMARY (
	NAME		= N'SQL2016Demo',
	FILENAME	= N'E:\DB\SQL2016Demo.mdf',
	SIZE		= 5120MB,
	MAXSIZE		= UNLIMITED,
	FILEGROWTH	= 1024MB
) LOG ON (
	NAME		= N'SQL2016Demo_log',
	FILENAME	= N'E:\DB\SQL2016Demo_log.ldf',
	SIZE		= 1024MB,
	MAXSIZE		= 4096MB,
	FILEGROWTH	= 1024MB
);
GO

ALTER DATABASE [SQL2016Demo] SET RECOVERY SIMPLE 
GO

USE SQL2016Demo;
CREATE TABLE dbo.Product
(
ProductID INT IDENTITY PRIMARY KEY,
ProductName VARCHAR(100) NOT NULL
)

CREATE TABLE dbo.Project
(
ProjectID INT IDENTITY PRIMARY KEY,
ProjectName VARCHAR(100) NOT NULL,
ProductID INT FOREIGN KEY REFERENCES dbo.Product(ProductID)
)
GO

INSERT INTO dbo.Product (ProductName) VALUES ('Product A');
INSERT INTO dbo.Project (ProjectName, ProductID)
VALUES ('Project A'
, ( SELECT ProductID FROM Product WHERE ProductName = 'Product A' )
);

SELECT * FROM dbo.Product;
SELECT * FROM dbo.Project;

GO
