-- scenariusz: domylne ustawienia indeksw (obie tabele: rowstore)

USE SQL2016Demo;
GO
-- BR: 5m12s (1CPU), 2m29s (2CPU) - oba RECOVERY FULL, 
-- wszystkie pozostae czasy dla RECOVERY SIMPLE, 2CPU

-- execution time: AV: 45s | BR: 1m12s | 1m1s | 1m4s
SELECT TOP 10000000
    ISNULL(p.ProductID + (a.number * 1000) + (b.number * 100000000),0) AS ProductID,
    p.Name + CONVERT(VARCHAR, (a.number * 1000)) AS Name,
    p.ProductNumber + '-' + CONVERT(VARCHAR, (a.number * 1000)) AS ProductNumber,
    p.MakeFlag,
    p.FinishedGoodsFlag,
    p.Color,
    p.SafetyStockLevel,
    p.ReorderPoint,
    p.StandardCost,
    p.ListPrice,
    p.Size,
    p.SizeUnitMeasureCode,
    p.WeightUnitMeasureCode,
    p.Weight,
    p.DaysToManufacture,
    p.ProductLine,
    p.Class,
    p.Style,
    p.ProductSubcategoryID,
    p.ProductModelID,
    p.SellStartDate,
    p.SellEndDate,
    p.DiscontinuedDate,
    cast('' as char(100)) as DataFiller 
INTO SQL2016Demo.dbo.ProductW1
FROM AdventureWorks2014.Production.Product AS p
CROSS JOIN master..spt_values AS a
CROSS JOIN master..spt_values AS b
WHERE a.type = 'p' and b.type= 'p' and b.number between 1 and 10

-- Data - 2975 MB 
exec sp_spaceused 'dbo.ProductW1'

go

-- BR: 3m57s | 4m26s | 4m34s
SELECT TOP 1000000 ProductID INTO dbo.ProductW1_SET1_1MLN FROM dbo.ProductW1
ORDER BY NEWID()

SELECT TOP 1000000 ProductID INTO dbo.ProductW1_SET2_1MLN FROM dbo.ProductW1
ORDER BY NEWID()

SELECT TOP 1000000 ProductID INTO dbo.ProductW1_SET3_1MLN FROM dbo.ProductW1
ORDER BY NEWID()

SELECT TOP 1000000 ProductID INTO dbo.ProductW1_SET4_1MLN FROM dbo.ProductW1
ORDER BY NEWID()






-- AV: 07m 08s | BR: 7m49s | 8m15s | 8m26s
ALTER TABLE dbo.ProductW1 ADD
	CONSTRAINT PK_ProductW1 PRIMARY KEY CLUSTERED (
		ProductID
	) WITH (
		STATISTICS_NORECOMPUTE	= OFF,
		IGNORE_DUP_KEY			= OFF
	) ON [PRIMARY]

-- Data - 2989 MB 
exec sp_spaceused 'dbo.ProductW1'

-- AV: 1s | BR: 43s | 47s | 35s
BEGIN TRAN
ALTER TABLE dbo.ProductW1 ADD
	PERIOD FOR SYSTEM_TIME (Valid_From, Valid_Till),
	Valid_From datetime2 GENERATED ALWAYS AS ROW START NOT NULL DEFAULT GETUTCDATE(),
	Valid_Till datetime2 GENERATED ALWAYS AS ROW END NOT NULL DEFAULT '9999-12-31 23:59:59.9999999';

ALTER TABLE dbo.ProductW1 SET (
	SYSTEM_VERSIONING = ON (HISTORY_TABLE = dbo.ProductW1_History, DATA_CONSISTENCY_CHECK = OFF)
)
COMMIT TRAN


-- AV: 366 seconds | BR: 5m37s == 337s | 5m42s == 342s | 5m14s == 314s
UPDATE  dbo.ProductW1
SET Weight = RAND()
WHERE ProductID in ( SELECT ProductID FROM  dbo.ProductW1_SET1_1MLN )
 
-- AV: 374 seconds | BR: 6m18s | 6m36s | 6m32s
DELETE FROM  dbo.ProductW1
WHERE ProductID in ( SELECT ProductID FROM  dbo.ProductW1_SET2_1MLN )

-- AV: 522s | BR: 8m27s | 8m42s | 9m1s
UPDATE  dbo.ProductW1
SET Weight = RAND()
WHERE ProductID in ( SELECT ProductID FROM  dbo.ProductW1_SET3_1MLN )

-- AV: 432s | BR: 7m45s | 7m52s | 8m04s
DELETE FROM  dbo.ProductW1
WHERE ProductID in ( SELECT ProductID FROM  dbo.ProductW1_SET4_1MLN )

-- overall: AV: 1694 seconds | BR: 28m7s == 1687s

-- data 453 MB | 454 MB | 454 MB | 454 MB
exec sp_spaceused '[dbo].[ProductW1_History]'

-- data 3 429 MB | 3454 MB | 3490 MB | 3492MB
exec sp_spaceused '[dbo].[ProductW1]'


-- BR: 36s | 11s | 1s
select distinct [Valid_From] from dbo.ProductW1_History

-- BR
--2015-11-16 20:38:17.9533333
--2015-11-16 20:41:08.2831684 <-- wybieramy rodkowy czas
--2015-11-16 20:54:17.3769001

--2015-11-18 08:39:34.8500000
--2015-11-18 08:40:41.4589621 <-- wybieramy rodkowy czas
--2015-11-18 08:54:34.8504563

--2015-11-18 10:19:30.1266667
--2015-11-18 10:20:19.9770409 <-- wybieramy rodkowy czas
--2015-11-18 10:33:36.8058368

-- AV
--2015-06-26 11:30:18.8530000
--2015-06-26 11:30:32.7154705
--2015-06-26 11:43:30.4298392

SET STATISTICS IO, TIME ON

--  SQL Server Execution Times:    CPU time = 31 ms,  elapsed time = 30 ms.
SELECT SUM(StandardCost), COUNT(*) from dbo.ProductW1
WHERE ProductID BETWEEN 100000000 AND 100200000


-- CPU time = 62 ms,  elapsed time = 63 ms.
SELECT SUM(StandardCost) FROM dbo.ProductW1
FOR SYSTEM_TIME AS OF '2015-11-18 10:20:19.9770409' 
WHERE ProductID BETWEEN 100000000 AND 100200000


-- 70 402 ms
SELECT SUM(StandardCost) FROM dbo.ProductW1
WHERE Weight > 0.5


--  CPU time = 11873 ms,  elapsed time = 84338 ms.
SELECT SUM(StandardCost) FROM dbo.ProductW1
FOR SYSTEM_TIME AS OF '2015-11-18 10:20:19.9770409' 
WHERE Weight > 0.5

/*
SQL Server parse and compile time: 
   CPU time = 10 ms, elapsed time = 10 ms.

 SQL Server Execution Times:
   CPU time = 0 ms,  elapsed time = 0 ms.
SQL Server parse and compile time: 
   CPU time = 0 ms, elapsed time = 0 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 1, logical reads 4322, physical reads 0, read-ahead reads 2601, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

 SQL Server Execution Times:
   CPU time = 31 ms,  elapsed time = 659 ms.

(1 row(s) affected)
Table 'ProductW1_History'. Scan count 1, logical reads 558, physical reads 0, read-ahead reads 99, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.
Table 'ProductW1'. Scan count 1, logical reads 4322, physical reads 0, read-ahead reads 0, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

 SQL Server Execution Times:
   CPU time = 47 ms,  elapsed time = 90 ms.
SQL Server parse and compile time: 
   CPU time = 0 ms, elapsed time = 0 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 3, logical reads 432897, physical reads 18, read-ahead reads 405586, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

 SQL Server Execution Times:
   CPU time = 2937 ms,  elapsed time = 103924 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 3, logical reads 432897, physical reads 59, read-ahead reads 431160, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.
Table 'ProductW1_History'. Scan count 3, logical reads 56940, physical reads 2, read-ahead reads 56750, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

 SQL Server Execution Times:
   CPU time = 4297 ms,  elapsed time = 117446 ms.

*/

/*
Drugie podejcie

SQL Server parse and compile time: 
   CPU time = 0 ms, elapsed time = 0 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 1, logical reads 4305, physical reads 0, read-ahead reads 3334, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

 SQL Server Execution Times:
   CPU time = 47 ms,  elapsed time = 886 ms.

(1 row(s) affected)
Table 'ProductW1_History'. Scan count 1, logical reads 564, physical reads 0, read-ahead reads 0, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.
Table 'ProductW1'. Scan count 1, logical reads 4305, physical reads 0, read-ahead reads 0, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

 SQL Server Execution Times:
   CPU time = 32 ms,  elapsed time = 43 ms.
SQL Server parse and compile time: 
   CPU time = 0 ms, elapsed time = 0 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 3, logical reads 437563, physical reads 137, read-ahead reads 422114, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

 SQL Server Execution Times:
   CPU time = 2672 ms,  elapsed time = 98454 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 3, logical reads 437368, physical reads 1, read-ahead reads 435767, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.
Table 'ProductW1_History'. Scan count 3, logical reads 56987, physical reads 0, read-ahead reads 56668, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

 SQL Server Execution Times:
   CPU time = 4687 ms,  elapsed time = 113183 ms.

*/

/*
Trzecia prba
SQL Server parse and compile time: 
   CPU time = 0 ms, elapsed time = 0 ms.

 SQL Server Execution Times:
   CPU time = 0 ms,  elapsed time = 0 ms.
SQL Server parse and compile time: 
   CPU time = 766 ms, elapsed time = 25965 ms.

 SQL Server Execution Times:
   CPU time = 0 ms,  elapsed time = 0 ms.
SQL Server parse and compile time: 
   CPU time = 0 ms, elapsed time = 0 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 1, logical reads 4303, physical reads 0, read-ahead reads 3058, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

(1 row(s) affected)

 SQL Server Execution Times:
   CPU time = 47 ms,  elapsed time = 1177 ms.

(1 row(s) affected)
Table 'ProductW1_History'. Scan count 1, logical reads 563, physical reads 0, read-ahead reads 0, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.
Table 'ProductW1'. Scan count 1, logical reads 4303, physical reads 0, read-ahead reads 0, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

(1 row(s) affected)

 SQL Server Execution Times:
   CPU time = 31 ms,  elapsed time = 559 ms.
SQL Server parse and compile time: 
   CPU time = 0 ms, elapsed time = 0 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 3, logical reads 437674, physical reads 276, read-ahead reads 430741, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

(1 row(s) affected)

 SQL Server Execution Times:
   CPU time = 2906 ms,  elapsed time = 105835 ms.

(1 row(s) affected)
Table 'ProductW1'. Scan count 3, logical reads 437724, physical reads 0, read-ahead reads 436020, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.
Table 'ProductW1_History'. Scan count 3, logical reads 56900, physical reads 2, read-ahead reads 56738, lob logical reads 0, lob physical reads 0, lob read-ahead reads 0.

(1 row(s) affected)

 SQL Server Execution Times:
   CPU time = 5079 ms,  elapsed time = 118108 ms.
SQL Server parse and compile time: 
   CPU time = 0 ms, elapsed time = 0 ms.

 SQL Server Execution Times:
   CPU time = 0 ms,  elapsed time = 0 ms.
*/