USE SQLDayLite2015;
GO

CREATE TABLE dbo.TblPK (
	Id			INT				NOT NULL,
	NazwaJakas	VARCHAR(200)	NULL,
	
	PERIOD FOR SYSTEM_TIME (WazneOd, WazneDo),

	WazneOd datetime2(0) GENERATED ALWAYS AS ROW START NOT NULL DEFAULT '1900-01-01',
	WazneDo datetime2(0) GENERATED ALWAYS AS ROW END NOT NULL DEFAULT '9999-12-31 23:59:59',

	CONSTRAINT [PK_TblPK] PRIMARY KEY CLUSTERED (
		Id,
		WazneOd,
		WazneDo
	)
)
GO

















-- jak na razie dziaa, to sprbujmy doda obsug wersjonowania
ALTER TABLE dbo.TblPK
SET (
	SYSTEM_VERSIONING = ON (HISTORY_TABLE = hist.TblPK, DATA_CONSISTENCY_CHECK = ON)
)

-- no popatrz, pozwoli - wtedy indeks jest dokadnie taki sam na tabeli gwnej i historycznej

ALTER TABLE dbo.TblPK
SET (
	SYSTEM_VERSIONING = OFF
)
GO

DROP TABLE dbo.TblPK;
GO

DROP TABLE hist.TblPK;
GO