USE SQLDayLite2015;
GO

CREATE TABLE dbo.TblKolumnyWyliczane (
	Id			INT				NOT NULL,
	NazwaJakas	VARCHAR(200)	NULL,
	Liczba1		INT				NULL,
	Liczba2		INT				NULL,
	Suma AS Liczba1 + Liczba2,
	
	PERIOD FOR SYSTEM_TIME (WazneOd, WazneDo),

	WazneOd datetime2(0) GENERATED ALWAYS AS ROW START NOT NULL DEFAULT '1900-01-01',
	WazneDo datetime2(0) GENERATED ALWAYS AS ROW END NOT NULL DEFAULT '9999-12-31 23:59:59',

	CONSTRAINT [PK_TblPK] PRIMARY KEY CLUSTERED (
		Id,
		WazneOd,
		WazneDo
	)
)
WITH (
	SYSTEM_VERSIONING = ON (HISTORY_TABLE = hist.TblKolumnyWyliczane)
)
GO

INSERT INTO dbo.TblKolumnyWyliczane (Id, NazwaJakas, Liczba1, Liczba2) VALUES
(1, 'Nazwa 1', 2, 4)

SELECT *
FROM dbo.TblKolumnyWyliczane

ALTER TABLE dbo.TblKolumnyWyliczane
SET (
	SYSTEM_VERSIONING = OFF
)
GO

DROP TABLE dbo.TblKolumnyWyliczane;
GO

DROP TABLE hist.TblKolumnyWyliczane;
GO