USE SQLDayLite2015;
GO


CREATE TABLE dbo.TblGenerated0 (
	Id			INT				NOT NULL,
	NazwaJakas	VARCHAR(200)	NULL,

	PERIOD FOR SYSTEM_TIME (WazneOd, WazneDo),

	WazneOd		DATETIME2(0),
	WazneDo		DATETIME2(0),

	CONSTRAINT [PK_TblGenerated0] PRIMARY KEY CLUSTERED (
		Id,
		WazneOd,
		WazneDo
	)
)
GO

CREATE TABLE dbo.TblGenerated (
	Id			INT				NOT NULL,
	NazwaJakas	VARCHAR(200)	NULL,

	WazneOd		DATETIME2(0),
	WazneDo		DATETIME2(0),

	CONSTRAINT [PK_TblGenerated] PRIMARY KEY CLUSTERED (
		Id,
		WazneOd,
		WazneDo
	)
)
GO

ALTER TABLE dbo.TblGenerated ADD
	PERIOD FOR SYSTEM_TIME (WazneOd, WazneDo)
;
GO


ALTER TABLE dbo.TblGenerated SET (
	SYSTEM_VERSIONING = ON (HISTORY_TABLE = hist.TblGenerated)
)
GO

INSERT INTO dbo.TblGenerated (Id, NazwaJakas) VALUES
(1, 'Nazwa 1');

WAITFOR DELAY '00:00:05';

INSERT INTO dbo.TblGenerated (Id, NazwaJakas) VALUES
(2, 'Nazwa 2');

SELECT *
FROM dbo.TblGenerated


ALTER TABLE dbo.TblGenerated
SET (
	SYSTEM_VERSIONING = OFF
)
GO

DROP TABLE dbo.TblGenerated;
GO

DROP TABLE hist.TblGenerated;
GO